;; Copyright (C) 2006 Jean-Pierre Mller CIRAD
;; for commodities
;;(require 'list-lib)
;;(require 'srfi-1)

;;(display self) (newline)
(define-syntax when
	(syntax-rules () ((when cond stmt1 ...) (if cond (begin stmt1 ...)))))

(define-syntax unless
	(syntax-rules () ((unless cond stmt1 ...) (if (not cond) (begin stmt1 ...)))))

(define-syntax for
	(syntax-rules () ((for (var list) stmt1 ...) (for-each (lambda (var) stmt1 ...) list))))
;	(syntax-rules () ((for (var list) stmt1 ...) (do ((lst list (cdr lst)) (var 0)) ((null? lst)) (set! var (car lst)) stmt1 ...))))

(define-syntax times
	(syntax-rules () ((times (var nb) stmt1 ...) (do ((var 0 (+ var 1))) ((= var nb)) stmt1 ...))))

;; Entry points into MIMOSA level 0:
;; - Getting a parameter value
(define (getParameter s)
;;	(display self) (newline)
	(invoke (as <mimosa.state.language.Scripting> (eval 'self (interaction-environment))) 'getParameter s))

;; Adding the created influence into the list of influence to send
(define (sendExternal portName typeName . args)
	(if (null? args)
		(invoke (as <mimosa.state.language.Scripting> (eval 'self (interaction-environment))) 'languageSendExternal portName typeName #!null)
		(invoke (as <mimosa.state.language.Scripting> (eval 'self (interaction-environment))) 'languageSendExternal portName typeName args)))

(define (sendLogical portName typeName . args)
	(if (null? args)
		(invoke (as <mimosa.state.language.Scripting> (eval 'self (interaction-environment))) 'languageSendLogical portName typeName #!null)
		(invoke (as <mimosa.state.language.Scripting> (eval 'self (interaction-environment))) 'languageSendLogical portName typeName args)))

;; Define the occurrence of the next spontaneous event as an internal transition
(define (sendInternal duration typeName . args)
	(if (null? args)
		(invoke (as <mimosa.state.language.Scripting> (eval 'self (interaction-environment))) 'languageSendInternal duration typeName #!null)
		(invoke (as <mimosa.state.language.Scripting> (eval 'self (interaction-environment))) 'languageSendInternal duration typeName args)))

(define (sendProbe probeName . args)
    (if (null? args)
        (invoke (as <mimosa.state.language.Scripting> (eval 'self (interaction-environment))) 'languageSendProbe probeName #!null)
    	(invoke (as <mimosa.state.language.Scripting> (eval 'self (interaction-environment))) 'languageSendProbe probeName args)))

(define (getInfluences name)
	(invoke (as <mimosa.state.language.Scripting> (eval 'self (interaction-environment))) 'getLanguageInfluences name))

(define (getAllInfluences)
	(invoke (as <mimosa.state.language.Scripting> (eval 'self (interaction-environment))) 'getLanguageAllInfluences))

(define (getInternalInfluence)
	(invoke (as <mimosa.state.DefaultState> (eval 'self (interaction-environment))) 'getInternalInfluence))
	
;; Structural changes
(define (addPort portRef behaviourName parameters)
        (invoke (as <mimosa.state.DefaultState> (eval 'self (interaction-environment))) 'addPort portRef behaviourName parameters))

(define (linkPort portRef1 portRef2)
        (invoke (as <mimosa.state.DefaultState> (eval 'self (interaction-environment))) 'linkPort portRef1 portRef2))

(define (removePort portRef)
        (invoke (as <mimosa.state.DefaultState> (eval 'self (interaction-environment))) 'removePort portRef))

;; - Getting MIMOSA influence
(define (is influence name)
	(invoke (as <mimosa.scheduler.Influence> influence) 'is name))

(define (contentOf influence)
	(invoke (as <mimosa.state.language.Scripting> (eval 'self (interaction-environment))) 'languageContentOf influence))

;; - construction utilities
(define (port name . args)
    (if (null? args)
        (invoke (as <mimosa.state.DefaultState> (eval 'self (interaction-environment))) 'port name)
        (invoke (as <mimosa.state.DefaultState> (eval 'self (interaction-environment))) 'port name (car args))))

(define (portRef . names)
	(invoke (as <mimosa.state.DefaultState> (eval 'self (interaction-environment))) 'languagePortRef names))

(define (pair name value)
	(invoke (as <mimosa.state.language.Scripting> (eval 'self (interaction-environment))) 'pair name value))

(define (parameters . pairs)
    (invoke (as <mimosa.state.DefaultState> (eval 'self (interaction-environment))) 'parameters pairs))
	
;; - Random generator
(define (newRandom seed)
	(invoke (as <mimosa.state.DefaultState> (eval 'self (interaction-environment))) 'newRandom seed))
(define (nextDouble generator)
	(invoke (as <mimosa.state.DefaultState> (eval 'self (interaction-environment))) 'nextDouble generator))
(define (nextBoolean generator)
	(invoke (as <mimosa.state.DefaultState> (eval 'self (interaction-environment))) 'nextBoolean generator))
(define (nextInt generator max)
	(invoke (as <mimosa.state.DefaultState> (eval 'self (interaction-environment))) 'nextInt generator max))

;; - Stopping the simulation
(define (stop)
    (invoke (as <mimosa.state.DefaultState> (eval 'self (interaction-environment))) 'stop))
    
;; - Debugging
;;(trace get-parameter)
;;(trace create-influence)
;;(trace add-output-influence)
;;(trace add-next-internal-transition)
;;(trace add-next-output-transition)
;;(trace is)
;;(trace contentOf)
;;(trace get-input-influences)
;;(trace newGenerator)
;;(trace nextDouble)
;;(trace nextBoolean)
;;(trace nextInt)



	