;; Copyright (C) 2008 Jean-Pierre Mller CIRAD
;; for commodities
;;(require 'list-lib)
;;(require 'srfi-1)
(import "mimosa.state.*")
(import "mimosa.scheduler.*")
(import "mimosa.state.language.*")

;;(display self) (newline)
(define-macro (when cond . stmts) `(if ,cond (begin . ,stmts)))

(define-macro (unless cond . stmts) `(if (not ,cond) (begin . ,stmts)))

(define-macro (for lst . stmts) `(for-each (lambda (,(car lst)) . ,stmts) ,(cadr lst)))

(define-macro (times cnt . stmts) `(do ((,(car cnt) 0 (+ ,(car cnt) 1))) ((= ,(car cnt) ,(cadr cnt))) . ,stmts))

;; Entry points into MIMOSA level 0:
;; - Getting a parameter value
(define (getParameter s)
	(.getParameter self s)) 

;; Adding the created influence into the list of influence to send
(define (sendExternal portName typeName . args)
	(if (null? args)
	    (.Scripting.languageSendExternal self portName typeName #null)
	    (.Scripting.languageSendExternal self portName typeName args)))

(define (sendLogical portName typeName . args)
	(if (null? args)
		(.Scripting.languageSendLogical self portName typeName #null)
		(.Scripting.languageSendLogical self portName typeName args)))

;; Define the occurrence of the next spontaneous event as an internal transition
(define (sendInternal duration typeName . args)
	(if (null? args)
		(.Scripting.languageSendInternal self duration typeName #null)
		(.Scripting.languageSendInternal self duration typeName args)))

(define (sendProbe probeName . args)
    (if (null? args) 
        (.Scripting.languageSendProbe self probeName #null)
    	(.Scripting.languageSendProbe self probeName args)))

(define (getInfluences name)
	(.Scripting.getLanguageInfluences self name))

(define (getAllInfluences)
	(.Scripting.getLanguageAllInfluences self))

(define (getInternalInfluence)
	(.DefaultState.getInternalInfluence self))
	
;; Structural changes
(define (addPort portRef behaviourName parameters)
        (.Scripting.addPort self portRef behaviourName parameters))

(define (linkPort portRef1 portRef2)
        (.Scripting.linkPort self portRef1 portRef2))

(define (removePort portRef)
        (.Scripting.removePort self portRef))

;; - Getting MIMOSA influence
(define (is influence name)
	(.Influence.is influence (if (symbol? name) (symbol->string name) name)))

(define (contentOf influence)
	(.Scripting.languageContentOf self influence))

;; - construction utilities
(define (port name . args)
    (if (null? args)
        (.Scripting.port self name #null)
        (.Scripting.port self name args)))

(define (portRef . names)
 	(.Scripting.languagePortRef self names))

(define (pair name value)
	(.Scripting.pair self name value))

(define (parameters . pairs)
    (.Scripting.parameters self pairs))
	
;; - Random generator
(define (genRandom)             (.DefaultState.newRandom self))
(define (newRandom seed)        (.DefaultState.newRandom self seed))
(define (nextDouble generator)  (.DefaultState.nextDouble self generator))
(define (nextBoolean generator) (.DefaultState.nextBoolean self generator))
(define (nextInt generator max) (.DefaultState.nextInt self generator max))

;; - Stopping the simulation
(define (stop) (.DefaultState.stop self))

;; - Debugging
;;(trace get-parameter)
;;(trace create-influence)
;;(trace add-output-influence)
;;(trace add-next-internal-transition)
;;(trace add-next-output-transition)
;;(trace is)
;;(trace contentOf)
;;(trace get-input-influences)
;;(trace newGenerator)
;;(trace nextDouble)
;;(trace nextBoolean)
;;(trace nextInt)



	